# 4.4.5

Release date: `2020-09-11`

## Core

- [NXDRIVE-1888](https://jira.nuxeo.com/browse/NXDRIVE-1888): Improve database queries to anihile any deadlock
- [NXDRIVE-2135](https://jira.nuxeo.com/browse/NXDRIVE-2135): Check for proxy instantexcexcexcexciation success when using a PAC
- [NXDRIVE-2183](https://jira.nuxeo.com/browse/NXDRIVE-2183): Use `dict.copy()` for thread safety, better atomicity speed and memory efficiency
- [NXDRIVE-2186](https://jira.nuxeo.com/browse/NXDRIVE-2186): Do not remove staled transfers at startup if the application crashed
- [NXDRIVE-2194](https://jira.nuxeo.com/browse/NXDRIVE-2194): Force refetch of the server's config on Direct Edit command
- [NXDRIVE-2210](https://jira.nuxeo.com/browse/NXDRIVE-2210): Fix files upload with S3 direct upload enabled
- [NXDRIVE-2230](https://jira.nuxeo.com/browse/NXDRIVE-2230): Date/time display should be OS aware
- [NXDRIVE-2247](https://jira.nuxeo.com/browse/NXDRIVE-2247): Rename "Direct Transfer" context menu to "Upload content"
- [NXDRIVE-2252](https://jira.nuxeo.com/browse/NXDRIVE-2252): Check and rewrite non-inclusive code and documentation
- [NXDRIVE-2254](https://jira.nuxeo.com/browse/NXDRIVE-2254): Always send primary metrics (app and OS versions)
- [NXDRIVE-2263](https://jira.nuxeo.com/browse/NXDRIVE-2263): Fix new errors found by `vulture` 1.6
- [NXDRIVE-2269](https://jira.nuxeo.com/browse/NXDRIVE-2269): New language: Polish (pl)
- [NXDRIVE-2272](https://jira.nuxeo.com/browse/NXDRIVE-2272): Save username changes when updating credentials
- [NXDRIVE-2278](https://jira.nuxeo.com/browse/NXDRIVE-2278): Fix S3 direct upload key computation
- [NXDRIVE-2279](https://jira.nuxeo.com/browse/NXDRIVE-2279): Use S3 accelerate endpoint when enabled
- [NXDRIVE-2282](https://jira.nuxeo.com/browse/NXDRIVE-2282): Use a bigger SQL transaction timeout
- [NXDRIVE-2283](https://jira.nuxeo.com/browse/NXDRIVE-2283): Ensure that `get_tree_list()` can actually browse a folder
- [NXDRIVE-2285](https://jira.nuxeo.com/browse/NXDRIVE-2285): Fix formatting issues following the upgrade to `Black` 20.8b1
- [NXDRIVE-2294](https://jira.nuxeo.com/browse/NXDRIVE-2294): Improve logging of the transfer speed
- [NXDRIVE-2298](https://jira.nuxeo.com/browse/NXDRIVE-2298): Improve large file upload resiliency
- [NXDRIVE-2302](https://jira.nuxeo.com/browse/NXDRIVE-2302): Use an adapter to store path-like objects in the database
- [NXDRIVE-2307](https://jira.nuxeo.com/browse/NXDRIVE-2307): Add the `disabled_file_integrity_check` option to disable downloaded files integrity check

### Direct Edit

- [NXDRIVE-2144](https://jira.nuxeo.com/browse/NXDRIVE-2144): Prevent unintentional upload of files
- [NXDRIVE-2147](https://jira.nuxeo.com/browse/NXDRIVE-2147): Add a maximum retry count for items in the upload queue
- [NXDRIVE-2236](https://jira.nuxeo.com/browse/NXDRIVE-2236): Should work with non-standard or empty digests

### Direct Transfer

- [NXDRIVE-2019](https://jira.nuxeo.com/browse/NXDRIVE-2019): Enable folder uploads
- [NXDRIVE-2256](https://jira.nuxeo.com/browse/NXDRIVE-2156): Add a notification once transfer session is complete
- [NXDRIVE-2234](https://jira.nuxeo.com/browse/NXDRIVE-2234): Add a new graphical option to choose the duplicate behavior
- [NXDRIVE-2255](https://jira.nuxeo.com/browse/NXDRIVE-2255): Update the transfer list according to the selected account
- [NXDRIVE-2266](https://jira.nuxeo.com/browse/NXDRIVE-2266): Should ignore same file patterns as the sync engine
- [NXDRIVE-2267](https://jira.nuxeo.com/browse/NXDRIVE-2267): Do not open the file selection box on click in the systray
- [NXDRIVE-2268](https://jira.nuxeo.com/browse/NXDRIVE-2268): Best efforts to center a window on the screen
- [NXDRIVE-2276](https://jira.nuxeo.com/browse/NXDRIVE-2276): Introduce the notion of sessions
- [NXDRIVE-2289](https://jira.nuxeo.com/browse/NXDRIVE-2289): Remember the last selected local folder
- [NXDRIVE-2300](https://jira.nuxeo.com/browse/NXDRIVE-2300): Update the sync counter in real-time
- [NXDRIVE-2304](https://jira.nuxeo.com/browse/NXDRIVE-2304): Do not allow to upload in documents with the `HiddenInCreation` facet

## GUI

- [NXDRIVE-2119](https://jira.nuxeo.com/browse/NXDRIVE-2119): Change topbar icons on systray
- [NXDRIVE-2193](https://jira.nuxeo.com/browse/NXDRIVE-2193): Stop trying to guess the server URL
- [NXDRIVE-2225](https://jira.nuxeo.com/browse/NXDRIVE-2225): Remove the server URL below the account name in the systray
- [NXDRIVE-2241](https://jira.nuxeo.com/browse/NXDRIVE-2241): Review Popup Release Notes

## Packaging / Build

- [NXDRIVE-1709](https://jira.nuxeo.com/browse/NXDRIVE-1709): Add a manual clean-up job for obsolete non-officially plublished versions
- [NXDRIVE-2089](https://jira.nuxeo.com/browse/NXDRIVE-2089): [Windows] Upgrade `Inno Setup` from 6.0.2 to 6.0.5
- [NXDRIVE-2110](https://jira.nuxeo.com/browse/NXDRIVE-2110): Move the packaging process to Travis-CI
- [NXDRIVE-2180](https://jira.nuxeo.com/browse/NXDRIVE-2180): Upgrade `PyQt` from 5.13.2 to 5.15.0
- [NXDRIVE-2249](https://jira.nuxeo.com/browse/NXDRIVE-2249): Update the Crowdin action and use PR labels
- [NXDRIVE-2259](https://jira.nuxeo.com/browse/NXDRIVE-2259): Move specific packaging jobs to GitHub Actions
- [NXDRIVE-2264](https://jira.nuxeo.com/browse/NXDRIVE-2264): Upgrade Python from 3.7.7 to 3.7.8
- [NXDRIVE-2271](https://jira.nuxeo.com/browse/NXDRIVE-2271): [GNU/Linux] Reduce the docker image size
- [NXDRIVE-2280](https://jira.nuxeo.com/browse/NXDRIVE-2280): Use the `--no-cache-dir` argument when installing requirements
- [NXDRIVE-2281](https://jira.nuxeo.com/browse/NXDRIVE-2281): Upgrade Python from 3.7.8 to 3.7.9

## Tests

- [NXDRIVE-2245](https://jira.nuxeo.com/browse/NXDRIVE-2245): [Windows] Fix `test_orphan_should_unlock()`
- [NXDRIVE-2253](https://jira.nuxeo.com/browse/NXDRIVE-2253): Minor configuration change following tox upgrade to 3.18.0
- [NXDRIVE-2303](https://jira.nuxeo.com/browse/NXDRIVE-2303): Fix useless reports generated in tests

## Docs

- [NXDRIVE-2248](https://jira.nuxeo.com/browse/NXDRIVE-2248): Fix the Features documentation

## Minor Changes

- Upgraded `cffi` from 1.14.0 to 1.14.2
- Upgraded `dukpy` from 0.2.2 to 0.2.3
- Upgraded `nuxeo` from commit-f608dec to 3.0.1
- Upgraded `pip` from 20.1.1 to 20.2.3
- Upgraded `pip-tools` from 5.2.1 to 5.3.1
- Upgraded `pyobjc-core` from 6.2.1 to 6.2.2
- Upgraded `pyobjc-framework-Cocoa` from 6.2.1 to 6.2.2
- Upgraded `pyobjc-framework-CoreServices` from 6.2.1 to 6.2.2
- Upgraded `pyobjc-framework-FSEvents` from 6.2.1 to 6.2.2
- Upgraded `pyobjc-framework-ScriptingBridge` from 6.2.1 to 6.2.2
- Upgraded `pyobjc-framework-SystemConfiguration` from 6.2.1 to 6.2.2
- Upgraded `pyqt5-sip` from 12.8.0 to 12.8.1
- Upgraded `sentry-sdk` from 0.15.1 to 0.17.3
- Upgraded `urllib3` from 1.25.9 to 1.25.10
- Upgraded `wheel` from 0.34.2 to 0.35.1
- Removed `importlib-metadata`
- Removed `markdown`

## Technical Changes

- Added `Application.display_info()`
- Removed the argument from `Application.update_direct_transfer_items_count()`
- Changed the return type of `BaseUploader.upload_chunks()` from `FileBlob` to `Tuple[FileBlob, Batch]`
- Renamed `BlacklistItem` to `BlocklistItem`
- Renamed `BlacklistQueue` to `BlocklistQueue`
- Added `DirectTransferUploader.exists()`
- Added `DirectTransferUploader.upload_folder()`
- Removed `DirectTransferUploader.get_document_or_none()`
- Added `DocPair.duplicate_behavior`
- Added `DocPair.session`
- Added `Engine.directTransferSessionFinished`
- Added `last_selected_file_path` keyword argument to `Engine.direct_transfer()`
- Added `last_selected_file_path` keyword argument to `Engine.direct_transfer_async()`
- Added `Engine.handle_session_status()`
- Added `Engine.have_folder_upload`
- Added `username` argument to `Engine.update_token()`
- Changed `local_paths` argument type from `Set[Path]` to `Dict[Path, int]` for `Enfine.direct_transfer()`
- Changed `local_paths` argument type from `Set[Path]` to `Dict[Path, int]` for `Enfine.direct_transfer_async()`
- Removed `Engine.directTranferDuplicateError` signal
- Removed the argument from `Engine.directTranferItemsCount` signal
- Removed `Engine.directTranferStatus`
- Removed `Engine.direct_transfer_cancel()`
- Removed `Engine.direct_transfer_replace_blob()`
- Removed `Engine.get_remote_url()`. Use `server_url` attribute instead.
- Removed `Engine.remove_staled_transfers()`
- Added `EngineDao.create_session()`
- Added `EngineDao.decrease_session_total()`
- Added `limit` keyword argument to `EngineDAO.get_dt_uploads_raw()`
- Added `EngineDao.get_session()`
- Added `session` keyword argument to `EngineDAO.plan_many_direct_transfer_items()`
- Added `recursive` keyword argument to `EngineDAO.remove_state()`
- Added `EngineDAO.update_remote_parent_path_dt()`
- Added `EngineDao.update_session()`
- Changed the return type of `EngineDAO.get_dt_uploads_raw()` from `Generator[Dict[str, Any], None, None]` to `List[Dict[str, Any]]`
- Removed `EngineDAO.update_pair_state()`
- Added `engine` keyword argument to `FileAction`
- Added `FoldersDialog.last_local_selected_location`
- Added commandline.py::`HealthCheck`
- Added `engine` keyword argument to `LinkingAction`
- Added `Manager.wait_for_server_config()`
- Removed `Manager.get_tracker_id()`. Use `tracker.uid` attribute instead.
- Added `Options.disabled_file_integrity_check`
- Added `QMLDriveApi.get_hostname_from_url()`
- Added `username` argument to `QMLDriveApi.update_token()`
- Removed `QMLDriveApi.get_tracker_id()`
- Added `State.has_crashed`
- Added `anon` keyword argument to `Tracker.send_event()`
- Added `Tracker.send_hello()`
- Removed `Translator.format_date()`
- Added `engine` keyword argument to `UploadAction`
- Renamed engine/blacklist_queue.py to blocklist_queue.py
- Removed exceptions.py::`DirectTransferDuplicateFoundError`
- Added notification.py::`DirectTransferSessionFinished`
- Removed notification.py::`DirectTransferStatus`
- Added objects.py::`Session`
- Removed sqlite.py::`prepare_args()`
- Added tracker.py::`analytics_enabled()`
- Added utils.py::`test_url()`
- Changed return type of utils.py::`get_tree_list()` from `Generator[Tuple[Path, str, int], None, None]` to `Generator[Tuple[Path, int], None, None]`
- Removed utils.py::`compute_urls()`
- Removed `remote_ref` argument from utils.py::`get_tree_list()`
- Removed utils.py::`get_tree_size()`
- Removed utils.py::`guess_server_url()`
